#
# Cookbook Name:: hypercontainer
# Recipe:: default
#
# Copyright 2017, whitestar
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#

pkgs = []

case node['platform_family']
#when 'rhel'
#   do nothing.
when 'debian'
  pkgs.push('libvirt0')

  case node['hypercontainer']['hypervisor']
  when 'qemu'
    pkgs.push('qemu')
  when 'xen'
    pkgs.push('xen-hypervisor-amd64')
  end
end

pkgs.each {|pkg|
  resources(package: pkg) rescue package pkg do
    action :install
  end
}

if node['hypercontainer']['install_flavor'] == 'script'
  execute 'install_hypercontainer_by_script' do
    command 'curl -sSL https://hypercontainer.io/install | bash'
    action :run
    not_if { File.exist?('/usr/bin/hyperctl') } unless node['hypercontainer']['auto_upgrade']
  end
end

srv = 'hyperd'
resources(service: srv) rescue service srv do
  action [:enable, :start]
end
